<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des évaluations</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total d'évaluation : {{ total }}</h3>
      </div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">
          Note moyenne d'utilisation :
          <b-rate v-model="noteMoyenneUtilisation" :disabled="true" icon="circle" :max="10" :show-score="true" /> Note
          moyenne des besoins :
          <b-rate v-model="noteMoyenneBesoin" :disabled="true" icon="circle" :max="10" :show-score="true" />
        </h3>
      </div>
      <mt-list v-slot="{ item: evaluer }" :list="evaluations">
        <mt-list-item>
          <div class="columns is-vcentered">
            <div class="column">{{ date(evaluer) }}</div>
            <div class="column">{{ evaluer.utilisateur.nom }} {{ evaluer.utilisateur.prenom }}</div>
            <div class="column">
              <b-rate
                v-model="evaluer.noteUtilisation"
                :disabled="true"
                icon="circle"
                size="is-small"
                :max="10"
                :show-score="true"
              />
            </div>
            <div class="column">
              <b-rate
                v-model="evaluer.noteBesoin"
                :disabled="true"
                icon="circle"
                size="is-small"
                :show-score="true"
                :max="10"
              />
            </div>
            <div class="column">
              <article class="commentaire">
                {{ evaluer.commentaire }}
              </article>
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Evaluationsuivante"
        aria-previous-label="Evaluation précedente"
        aria-page-label="Evaluation"
        aria-current-label="Page courante"
        @change="getEvaluation"
      />
    </div>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const [
      { content: evaluations, totalElements: total, numberOfElements: nombrePageCourante },
      noteMoyenneBesoin,
      noteMoyenneUtilisation,
      ,
    ] = await Promise.all([
      $api.evaluations.allPage(pageCourante - 1, parPage),
      $api.evaluations.moyenneBesoin(),
      $api.evaluations.moyenneUtilisation(),
    ]);

    return {
      evaluations,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      noteMoyenneBesoin,
      noteMoyenneUtilisation,
    };
  },
  methods: {
    async getEvaluation(page) {
      this.pageCourante = page;
      ({
        content: this.evaluations,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.evaluations.allPage(this.pageCourante - 1, this.parPage));
    },
    date({ dateCreation }) {
      if (!dateCreation) {
        return '';
      }
      return DateTime.fromISO(dateCreation)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy HH:mm');
    },
  },
};
</script>

<style scoped lang="scss">
.commentaire {
  text-align: justify;
  word-break: break-all;
}
</style>
